import "./style.css";
import { callEntry as d, useCanvas as c, useNotify as f, useModal as v, useHelp as V, useLayout as I, useCompile as oe } from "@opentiny/tiny-engine-meta-register";
import { reactive as $, ref as ne, nextTick as ee, watch as re, onActivated as ie, provide as se, onBeforeUnmount as ae, resolveComponent as q, createBlock as ce, openBlock as le, withCtx as K, createElementVNode as Q, createVNode as Z, withDirectives as de, vShow as ue, createTextVNode as pe } from "vue";
import { Button as me } from "@opentiny/vue";
import { PluginPanel as J, VueMonaco as z } from "@opentiny/tiny-engine-common";
import { initCompletion as H } from "@opentiny/tiny-engine-common/js/completion";
import { lint as C, initLinter as G } from "@opentiny/tiny-engine-common/js/linter";
import { formatString as y, insertName as x, ast2String as D, string2Ast as S } from "@opentiny/tiny-engine-common/js/ast";
import { constants as L } from "@opentiny/tiny-engine-utils";
import { isFunction as E } from "@opentiny/vue-renderless/grid/static";
const j = {
  id: "engine.plugins.pagecontroller",
  title: "页面 JS",
  type: "plugins",
  icon: "plugin-icon-js",
  align: "leftTop",
  width: 600,
  widthResizable: !0,
  confirm: "close"
  // 当点击插件栏切换或关闭前是否需要确认, 会调用插件中confirm值指定的方法，e.g. 此处指向 close方法，会调用插件的close方法执行确认逻辑
}, {
  SCHEMA_DATA_TYPE: M
} = L, r = $({
  linterWorker: null,
  script: "",
  isChanged: !1,
  hasError: !1,
  editorSelection: null,
  completionProvider: null,
  // 记录当前是否已经有弹窗，防止使用 ctrl + s 的时候重复弹窗
  hasErrorPopup: !1
}), s = ne(null);
let u = null;
const i = d(() => {
  var e, n;
  const t = ((n = (e = c()).getSchema) == null ? void 0 : n.call(e)) || {};
  return t.methods = (t == null ? void 0 : t.methods) || {}, t.methods;
}, {
  metaData: {
    id: "engine.plugins.pagecontroller.getMethods"
  },
  ctx: () => ({
    useCanvas: c,
    useModal: v,
    useNotify: f,
    string2Ast: S,
    ast2String: D,
    insertName: x,
    formatString: y,
    constants: L,
    lint: C,
    isFunction: E,
    SCHEMA_DATA_TYPE: M,
    state: r,
    monaco: s,
    scriptAst: u,
    getMethods: i,
    getMethodNameList: p,
    getMethodContentList: N,
    getScriptString: h,
    change: b,
    saveMethod: m,
    saveMethods: _,
    close: w,
    setEditorSelection: P,
    highlightMethod: g
  })
}), p = d(() => c().pageState.pageSchema && Object.keys(i()) || [], {
  metaData: {
    id: "engine.plugins.pagecontroller.getMethodNameList"
  },
  ctx: () => ({
    useCanvas: c,
    useModal: v,
    useNotify: f,
    string2Ast: S,
    ast2String: D,
    insertName: x,
    formatString: y,
    constants: L,
    lint: C,
    isFunction: E,
    SCHEMA_DATA_TYPE: M,
    state: r,
    monaco: s,
    scriptAst: u,
    getMethods: i,
    getMethodNameList: p,
    getMethodContentList: N,
    getScriptString: h,
    change: b,
    saveMethod: m,
    saveMethods: _,
    close: w,
    setEditorSelection: P,
    highlightMethod: g
  })
}), N = d(() => Object.values(i()).map((t) => t.value), {
  metaData: {
    id: "engine.plugins.pagecontroller.getMethodContentList"
  },
  ctx: () => ({
    useCanvas: c,
    useModal: v,
    useNotify: f,
    string2Ast: S,
    ast2String: D,
    insertName: x,
    formatString: y,
    constants: L,
    lint: C,
    isFunction: E,
    SCHEMA_DATA_TYPE: M,
    state: r,
    monaco: s,
    scriptAst: u,
    getMethods: i,
    getMethodNameList: p,
    getMethodContentList: N,
    getScriptString: h,
    change: b,
    saveMethod: m,
    saveMethods: _,
    close: w,
    setEditorSelection: P,
    highlightMethod: g
  })
}), h = d(() => {
  const e = Object.entries(i()).map(([n, o]) => x(n, o.value)).join(`
`);
  try {
    u = S(e);
  } catch (n) {
    f({
      type: "error",
      message: `代码静态检查有错误：${n}`
    });
  }
  return e;
}, {
  metaData: {
    id: "engine.plugins.pagecontroller.getScriptString"
  },
  ctx: () => ({
    useCanvas: c,
    useModal: v,
    useNotify: f,
    string2Ast: S,
    ast2String: D,
    insertName: x,
    formatString: y,
    constants: L,
    lint: C,
    isFunction: E,
    SCHEMA_DATA_TYPE: M,
    state: r,
    monaco: s,
    scriptAst: u,
    getMethods: i,
    getMethodNameList: p,
    getMethodContentList: N,
    getScriptString: h,
    change: b,
    saveMethod: m,
    saveMethods: _,
    close: w,
    setEditorSelection: P,
    highlightMethod: g
  })
}), b = d((t) => {
  const e = /\r\n/g;
  if (r.isChanged = t.replace(e, `
`) !== r.script.replace(e, `
`), !s.value)
    return;
  const n = s.value.getEditor().getModel();
  C(n, r.linterWorker);
}, {
  metaData: {
    id: "engine.plugins.pagecontroller.change"
  },
  ctx: () => ({
    useCanvas: c,
    useModal: v,
    useNotify: f,
    string2Ast: S,
    ast2String: D,
    insertName: x,
    formatString: y,
    constants: L,
    lint: C,
    isFunction: E,
    SCHEMA_DATA_TYPE: M,
    state: r,
    monaco: s,
    scriptAst: u,
    getMethods: i,
    getMethodNameList: p,
    getMethodContentList: N,
    getScriptString: h,
    change: b,
    saveMethod: m,
    saveMethods: _,
    close: w,
    setEditorSelection: P,
    highlightMethod: g
  })
}), m = d(({
  name: t,
  content: e
}) => {
  if (!t)
    return;
  const n = i(), o = {
    type: M.JSFunction,
    value: e
  };
  c().updateSchema({
    methods: {
      ...n,
      [t]: o
    }
  });
}, {
  metaData: {
    id: "engine.plugins.pagecontroller.saveMethod"
  },
  ctx: () => ({
    useCanvas: c,
    useModal: v,
    useNotify: f,
    string2Ast: S,
    ast2String: D,
    insertName: x,
    formatString: y,
    constants: L,
    lint: C,
    isFunction: E,
    SCHEMA_DATA_TYPE: M,
    state: r,
    monaco: s,
    scriptAst: u,
    getMethods: i,
    getMethodNameList: p,
    getMethodContentList: N,
    getScriptString: h,
    change: b,
    saveMethod: m,
    saveMethods: _,
    close: w,
    setEditorSelection: P,
    highlightMethod: g
  })
}), _ = d(async () => {
  const {
    message: t
  } = v();
  if (!r.isChanged || r.hasErrorPopup)
    return !1;
  if (r.hasError)
    return r.hasErrorPopup = !0, t({
      status: "error",
      message: "代码静态检查有错误，请先修改后再保存",
      exec: () => {
        r.hasErrorPopup = !1;
      }
    }), !1;
  const e = s.value.getEditor().getValue(), n = S(e), o = {};
  n.program.body.forEach((l, k) => {
    var U, W;
    const T = (U = l == null ? void 0 : l.id) == null ? void 0 : U.name;
    (W = n.program.body[k + 1]) != null && W.leadingComments && l.trailingComments === n.program.body[k + 1].leadingComments && delete l.trailingComments;
    const B = y(D(l).trim(), "javascript");
    T && (o[T] = {
      type: M.JSFunction,
      value: B
    });
  }), c().updateSchema({
    methods: o
  }), c().setSaved(!1);
  const a = h();
  return r.script = "", await ee(), r.script = a, r.isChanged = !1, f({
    type: "success",
    message: "保存成功！"
  }), !0;
}, {
  metaData: {
    id: "engine.plugins.pagecontroller.saveMethods"
  },
  ctx: () => ({
    useCanvas: c,
    useModal: v,
    useNotify: f,
    string2Ast: S,
    ast2String: D,
    insertName: x,
    formatString: y,
    constants: L,
    lint: C,
    isFunction: E,
    SCHEMA_DATA_TYPE: M,
    state: r,
    monaco: s,
    scriptAst: u,
    getMethods: i,
    getMethodNameList: p,
    getMethodContentList: N,
    getScriptString: h,
    change: b,
    saveMethod: m,
    saveMethods: _,
    close: w,
    setEditorSelection: P,
    highlightMethod: g
  })
}), w = d((t) => (e) => {
  const {
    confirm: n
  } = v(), o = E(e) ? e : () => t("close");
  if (!r.isChanged) {
    o(!0);
    return;
  }
  n({
    title: "提示",
    message: "有改动未保存，您确定保存并关闭吗？",
    exec() {
      o(_());
    },
    cancel() {
      o(!0);
    }
  });
}, {
  metaData: {
    id: "engine.plugins.pagecontroller.close"
  },
  ctx: () => ({
    useCanvas: c,
    useModal: v,
    useNotify: f,
    string2Ast: S,
    ast2String: D,
    insertName: x,
    formatString: y,
    constants: L,
    lint: C,
    isFunction: E,
    SCHEMA_DATA_TYPE: M,
    state: r,
    monaco: s,
    scriptAst: u,
    getMethods: i,
    getMethodNameList: p,
    getMethodContentList: N,
    getScriptString: h,
    change: b,
    saveMethod: m,
    saveMethods: _,
    close: w,
    setEditorSelection: P,
    highlightMethod: g
  })
}), P = d(() => {
  if (!r.editorSelection || !s.value)
    return;
  const t = s.value.getEditor();
  t.setSelection(r.editorSelection), t.focus();
  const e = t.getTopForLineNumber(r.editorSelection.startLineNumber - 1);
  t.setScrollPosition({
    scrollLeft: 0,
    scrollTop: e
  }, 0);
}, {
  metaData: {
    id: "engine.plugins.pagecontroller.setEditorSelection"
  },
  ctx: () => ({
    useCanvas: c,
    useModal: v,
    useNotify: f,
    string2Ast: S,
    ast2String: D,
    insertName: x,
    formatString: y,
    constants: L,
    lint: C,
    isFunction: E,
    SCHEMA_DATA_TYPE: M,
    state: r,
    monaco: s,
    scriptAst: u,
    getMethods: i,
    getMethodNameList: p,
    getMethodContentList: N,
    getScriptString: h,
    change: b,
    saveMethod: m,
    saveMethods: _,
    close: w,
    setEditorSelection: P,
    highlightMethod: g
  })
}), g = d((t) => {
  var o;
  if (!t)
    return;
  const e = u == null ? void 0 : u.program.body.filter((a) => {
    var l;
    return t === ((l = a == null ? void 0 : a.id) == null ? void 0 : l.name);
  });
  if (e.length === 0)
    return;
  const n = (o = e[0]) == null ? void 0 : o.loc;
  n && (r.editorSelection = {
    startColumn: n.start.column,
    startLineNumber: n.start.line,
    endColumn: n.end.column + 1,
    endLineNumber: n.end.line
  }), r.editorSelection && P();
}, {
  metaData: {
    id: "engine.plugins.pagecontroller.highlightMethod"
  },
  ctx: () => ({
    useCanvas: c,
    useModal: v,
    useNotify: f,
    string2Ast: S,
    ast2String: D,
    insertName: x,
    formatString: y,
    constants: L,
    lint: C,
    isFunction: E,
    SCHEMA_DATA_TYPE: M,
    state: r,
    monaco: s,
    scriptAst: u,
    getMethods: i,
    getMethodNameList: p,
    getMethodContentList: N,
    getScriptString: h,
    change: b,
    saveMethod: m,
    saveMethods: _,
    close: w,
    setEditorSelection: P,
    highlightMethod: g
  })
}), R = ({
  emit: t
}) => (re(h, (e) => {
  r.script = e;
}), ie(d(() => {
  ee(() => {
    var e;
    r.script = h(), (e = s.value) == null || e.focus(), window.dispatchEvent(new Event("resize"));
  });
}, {
  metaData: {
    id: "engine.plugins.pagecontroller.onActivated[0]"
  },
  ctx: () => ({
    emit: t,
    useCanvas: c,
    useModal: v,
    useNotify: f,
    string2Ast: S,
    ast2String: D,
    insertName: x,
    formatString: y,
    constants: L,
    lint: C,
    isFunction: E,
    SCHEMA_DATA_TYPE: M,
    state: r,
    monaco: s,
    scriptAst: u,
    getMethods: i,
    getMethodNameList: p,
    getMethodContentList: N,
    getScriptString: h,
    change: b,
    saveMethod: m,
    saveMethods: _,
    close: w,
    setEditorSelection: P,
    highlightMethod: g
  })
})), {
  state: r,
  monaco: s,
  change: b,
  saveMethods: _,
  close: w(t)
}), Y = {
  saveMethod: m,
  highlightMethod: g,
  getMethodNameList: p,
  getMethods: i
}, ge = {
  components: {
    MonacoEditor: z,
    TinyButton: me,
    PluginPanel: J
  },
  props: {
    fixedPanels: {
      type: Array
    }
  },
  emits: ["close"],
  setup(t, {
    emit: e
  }) {
    const n = V().getDocsUrl("script"), {
      state: o,
      monaco: a,
      change: l,
      close: k,
      saveMethods: T
    } = R({
      emit: e
    }), {
      PLUGIN_NAME: B
    } = I(), U = $({
      emitEvent: e
    });
    se("panelState", U);
    const W = {
      language: "javascript",
      minimap: {
        enabled: !1
      },
      placeholder: `// ✅ 函数声明可以保存
       function topLevelFunction(){ 
      ​ ​ const message = 'hello tiny-engine.' 
      ​ ​ console.log(message) 
      } 
 
      // ❌ 顶层/常规 变量声明 
 const someVariable = 42 
      // ❌ 表达式 
 const result = someVariable + 10`,
      // 禁用滚动条边边一直显示的边框
      overviewRulerBorder: !1,
      renderLineHighlightOnlyWhenFocus: !0,
      tabSize: 2,
      insertSpaces: !0,
      formatOnPaste: !0,
      formatOnType: !0,
      autoIndent: "full",
      newLineCharacter: `
`,
      convertTabsToSpaces: !0,
      trimAutoWhitespace: !0,
      wordWrap: "on",
      wordWrapColumn: 120,
      wordWrapMinChars: 10,
      wordWrapStrategy: "advanced"
    }, F = d((O) => {
      var A;
      a.value && (o.completionProvider = H(a.value.getMonaco(), (A = a.value.getEditor()) == null ? void 0 : A.getModel()), o.linterWorker = G(O, a.value.getMonaco(), o));
    }, {
      metaData: {
        id: `${j.id}.editorDidMount`
      },
      ctx: () => ({
        props: t,
        emit: e,
        docsUrl: n,
        state: o,
        monaco: a,
        change: l,
        close: k,
        saveMethods: T,
        PLUGIN_NAME: B,
        panelState: U,
        options: W,
        editorDidMount: F,
        VueMonaco: z,
        PluginPanel: J,
        useHelp: V,
        useLayout: I,
        initCompletion: H,
        initLinter: G,
        useMethod: R,
        saveMethod: m,
        highlightMethod: g,
        getMethodNameList: p,
        getMethods: i,
        api: Y
      })
    });
    return ae(d(d(() => {
      var O, A, X;
      (O = o.completionProvider) == null || O.forEach((te) => {
        te.dispose();
      }), (X = (A = o.linterWorker) == null ? void 0 : A.terminate) == null || X.call(A);
    }, {
      metaData: {
        id: `${j.id}.onBeforeUnmount[0]`
      },
      ctx: () => ({
        props: t,
        emit: e,
        docsUrl: n,
        state: o,
        monaco: a,
        change: l,
        close: k,
        saveMethods: T,
        PLUGIN_NAME: B,
        panelState: U,
        options: W,
        editorDidMount: F,
        VueMonaco: z,
        PluginPanel: J,
        useHelp: V,
        useLayout: I,
        initCompletion: H,
        initLinter: G,
        useMethod: R,
        saveMethod: m,
        highlightMethod: g,
        getMethodNameList: p,
        getMethods: i,
        api: Y
      })
    }), {
      metaData: {
        id: `${j.id}.onBeforeUnmount[0]`
      },
      ctx: () => ({
        props: t,
        emit: e,
        docsUrl: n,
        state: o,
        monaco: a,
        change: l,
        close: k,
        saveMethods: T,
        PLUGIN_NAME: B,
        panelState: U,
        options: W,
        editorDidMount: F,
        _callEntry: d,
        _useCompile: oe,
        _metaData: j,
        VueMonaco: z,
        PluginPanel: J,
        useHelp: V,
        useLayout: I,
        initCompletion: H,
        initLinter: G,
        useMethod: R,
        saveMethod: m,
        highlightMethod: g,
        getMethodNameList: p,
        getMethods: i,
        api: Y
      })
    })), {
      PLUGIN_NAME: B,
      state: o,
      monaco: a,
      options: W,
      close: k,
      change: l,
      saveMethods: T,
      editorDidMount: F,
      docsUrl: n
    };
  }
}, he = (t, e) => {
  const n = t.__vccOpts || t;
  for (const [o, a] of e)
    n[o] = a;
  return n;
}, fe = { class: "icon-wrap" }, ve = { class: "red" }, Se = { class: "code-edit-content" };
function Me(t, e, n, o, a, l) {
  const k = q("tiny-button"), T = q("monaco-editor"), B = q("plugin-panel");
  return le(), ce(B, {
    title: "页面 JS",
    "fixed-name": o.PLUGIN_NAME.Page,
    fixedPanels: n.fixedPanels,
    docsUrl: o.docsUrl,
    isShowDocsIcon: !0,
    onClose: e[0] || (e[0] = (U) => t.$emit("close")),
    class: "plugin-page-js-container plugin-script"
  }, {
    header: K(() => [
      Q("span", fe, [
        de(Q("i", ve, null, 512), [
          [ue, o.state.isChanged]
        ]),
        Z(k, {
          type: "primary",
          onClick: o.saveMethods
        }, {
          default: K(() => e[1] || (e[1] = [
            pe("保存")
          ])),
          _: 1
        }, 8, ["onClick"])
      ])
    ]),
    content: K(() => [
      Q("div", Se, [
        Z(T, {
          ref: "monaco",
          value: o.state.script,
          options: o.options,
          onChange: o.change,
          onEditorDidMount: o.editorDidMount,
          onShortcutSave: o.saveMethods
        }, null, 8, ["value", "options", "onChange", "onEditorDidMount", "onShortcutSave"])
      ])
    ]),
    _: 1
  }, 8, ["fixed-name", "fixedPanels", "docsUrl"]);
}
const _e = /* @__PURE__ */ he(ge, [["render", Me], ["__scopeId", "data-v-e7e3bd99"]]), ke = {
  ...j,
  apis: Y,
  entry: _e
};
export {
  ke as default
};
